/*
 * yopytoday 
 *
 * Choi Jonghwan <saxboy@freechal.com>
 * 2002/04/10
 */

#include <stdio.h>
#include <dlfcn.h>
#include <dirent.h>
#include <sys/types.h>
#include <gnome.h>
#include <ctype.h>
#include "yopytoday.h"
#include "yopytoday_resource.h"
#include "ytplugin.h"
#include "util.h"

typedef struct __YOPYTODAY {

	GtkWidget *window; 
	GtkWidget *scrolledwin; 
	GtkWidget *vbox; 

	GList *plugin_list; 

} _YOPYTODAY; 

static int _yopytoday_create_interface(YOPYTODAY yt); 


YOPYTODAY yopytoday_New(void)
{
	YOPYTODAY yt=NULL; 

	if ( (yt=calloc(1, sizeof(_YOPYTODAY) ))==NULL) 
		return NULL; 

	if ( _yopytoday_create_interface(yt) < 0 )
		goto return_error; 

	return yt; 

return_error:
	if (yt!=NULL) free(yt); 
	return NULL; 
}

int yopytoday_Delete(YOPYTODAY yt)
{
	if (yt==NULL) return -1; 

	free(yt); 

	return 1; 
}
static gboolean _yopytoday_logo_click_cb (
	GtkWidget *widget, GdkEventButton *event, gpointer user_data)
{
	pid_t childpid; 
	YOPYTODAY yt = (YOPYTODAY)(user_data); 

	execute_command_background("yopytoday_conf", &childpid); 
	return TRUE; 
}

static GtkWidget *__yopytoday_get_plugin_info_widget(YT_PLUGIN p)
{
	GtkWidget *piwidget=NULL; 
	char temptext[128]={0,}; 
	char *_titles[]={"׸", ""}; 

	if (p==NULL) return NULL; 

	piwidget = gtk_clist_new_with_titles(2, _titles); 

	/* FIXME: dummy... hmm. */
	gtk_clist_append( GTK_CLIST(piwidget), _titles); 
	gtk_clist_append( GTK_CLIST(piwidget), _titles); 
	gtk_clist_append( GTK_CLIST(piwidget), _titles); 
	gtk_clist_append( GTK_CLIST(piwidget), _titles); 
	gtk_clist_append( GTK_CLIST(piwidget), _titles); 
	gtk_clist_append( GTK_CLIST(piwidget), _titles); 
	gtk_clist_append( GTK_CLIST(piwidget), _titles); 
	gtk_clist_append( GTK_CLIST(piwidget), _titles); 
	gtk_clist_append( GTK_CLIST(piwidget), _titles); 

	gtk_clist_set_column_visibility( GTK_CLIST(piwidget), 0, TRUE); 
	gtk_clist_set_column_visibility( GTK_CLIST(piwidget), 1, TRUE); 
	gtk_clist_set_column_auto_resize( GTK_CLIST(piwidget), 0, TRUE); 
	gtk_clist_set_column_auto_resize( GTK_CLIST(piwidget), 1, TRUE); 

	gtk_clist_set_text( GTK_CLIST(piwidget), 0, 0, "÷̸"); 
	gtk_clist_set_text( GTK_CLIST(piwidget), 0, 1, strdup(p->name)); 

	gtk_clist_set_text( GTK_CLIST(piwidget), 1, 0, "÷ι"); 
	gtk_clist_set_text( GTK_CLIST(piwidget), 1, 1, strdup(p->version)); 

	gtk_clist_set_text( GTK_CLIST(piwidget), 2, 0, ""); 
	gtk_clist_set_text( GTK_CLIST(piwidget), 2, 1, strdup(p->author)); 

	gtk_clist_set_text( GTK_CLIST(piwidget), 3, 0, "Ȩ"); 
	gtk_clist_set_text( GTK_CLIST(piwidget), 3, 1, strdup(p->author_url)); 

	gtk_clist_set_text( GTK_CLIST(piwidget), 4, 0, "̸"); 
	gtk_clist_set_text( GTK_CLIST(piwidget), 4, 1, strdup(p->author_email)); 

	gtk_clist_set_text( GTK_CLIST(piwidget), 5, 0, "¥"); 
	gtk_clist_set_text( GTK_CLIST(piwidget), 5, 1, strdup(p->date)); 

	gtk_clist_set_text( GTK_CLIST(piwidget), 6, 0, "ũ"); 
	sprintf( temptext, "%d", p->res_x_request ); 
	gtk_clist_set_text( GTK_CLIST(piwidget), 6, 1, strdup(temptext)); 

	gtk_clist_set_text( GTK_CLIST(piwidget), 7, 0, "ũ"); 
	sprintf( temptext, "%d", p->res_y_request ); 
	gtk_clist_set_text( GTK_CLIST(piwidget), 7, 1, strdup(temptext)); 

	/* set icon pixmap */
	{
		GdkPixmap *pixmap=NULL,*bitmap=NULL; 
		GdkImlibImage *im=NULL; 
		char iconpath[1024]={0,}; 

		sprintf(iconpath, "%s/%s", YT_RESOURCE_DIR, p->iconpath); 

		if ( (im=gdk_imlib_load_image( (char *)iconpath))!=NULL)
		{
			gdk_imlib_render(im, im->rgb_width, im->rgb_height); 

			if ( (pixmap=gdk_imlib_move_image(im))!=NULL)
				gdk_pixmap_ref(pixmap); 
			if ( (bitmap=gdk_imlib_move_mask(im))!=NULL)
				gdk_pixmap_ref(bitmap); 

			gtk_clist_set_text( GTK_CLIST(piwidget), 8, 0, ""); 
			gtk_clist_set_pixmap( GTK_CLIST(piwidget), 8, 1, pixmap, bitmap); 

			gdk_imlib_destroy_image(im); 
		}
		else 
		{
			printf("loading [%s] failed \n", iconpath); 
		}
	}

	return 	piwidget; 
}

/* FIXME: handler too long. separate to another func
 */
static gboolean _yopytoday_plugin_icon_click_cb (
	GtkWidget *widget, GdkEventButton *event, gpointer user_data)
{
	YT_PLUGIN p = (YT_PLUGIN)user_data; 
	GtkWidget *plugin_config_widget=NULL; 
	GtkWidget *plugin_help_widget=NULL; 

	/* get plugin configure window 
	 */
	if ( p->yt_plugin_get_config_window !=NULL)
		plugin_config_widget = (*p->yt_plugin_get_config_window)(); 

	if ( plugin_config_widget==NULL) 
	{
		plugin_config_widget = gtk_label_new(YT_TEXT_CONFIGURE_NOT_SUPPORTED); 
	}

	/* get plugin help widget
	 */
	plugin_help_widget = gtk_label_new(YT_TEXT_HELP_NOT_SUPPORTED); 

	/* now launch plugin configure/about window 
	 */
	{
		GtkWidget *newwindow=NULL; 
			GtkWidget *notebook=NULL; 
				GtkWidget *aboutbox=NULL; 

		newwindow = gtk_window_new(GTK_WINDOW_DIALOG); 
		gtk_widget_set_usize( newwindow, SCREEN_WIDTH, SCREEN_HEIGHT); 


		notebook = gtk_notebook_new(); 

		/* add about box 
		 */
		aboutbox = __yopytoday_get_plugin_info_widget(p); 

		/* set children
		 */
		gtk_notebook_append_page( 
			GTK_NOTEBOOK(notebook), 
			aboutbox, 
			gtk_label_new( YT_TEXT_INFO ) ); 

		gtk_notebook_append_page( 
			GTK_NOTEBOOK(notebook), 
			plugin_config_widget, 
			gtk_label_new(YT_TEXT_CONFIGURE)); 

		gtk_notebook_append_page( 
			GTK_NOTEBOOK(notebook), 
			plugin_help_widget, 
			gtk_label_new(YT_TEXT_HELP )); 

		gtk_container_add( GTK_CONTAINER(newwindow), notebook); 

printf("show configure window\n"); 
		gtk_widget_show_all( newwindow); 
	}

	return TRUE; 
}


static void _yopytoday_destroy_cb(
		GtkWidget *widget, GdkEvent *e, gpointer user_data)
{
	YOPYTODAY yt = (YOPYTODAY)(user_data); 

	yopytoday_UnregisterPluginAll(yt); 
	yopytoday_Delete(yt); 
	gtk_main_quit(); 

	exit(1); 
}

static int _yopytoday_create_interface(YOPYTODAY yt)
{
	if (yt==NULL) return -1; 

	yt->window = gtk_window_new(GTK_WINDOW_TOPLEVEL); 
	gtk_widget_set_usize( yt->window, SCREEN_WIDTH, SCREEN_HEIGHT); 

	yt->scrolledwin = gtk_scrolled_window_new( NULL, NULL); 
	gtk_scrolled_window_set_policy( 
		GTK_SCROLLED_WINDOW(yt->scrolledwin), 
		GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC); 

	yt->vbox = gtk_vbox_new(FALSE, 0); 

	gtk_container_add(GTK_CONTAINER(yt->window), yt->scrolledwin); 
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(yt->scrolledwin), yt->vbox); 

	/* append logo, run configurator on click
	 * as pixmap does not get events, use event box
	 */
	{
		GtkWidget *eventbox=NULL; 

		eventbox = gtk_event_box_new(); 
		gtk_container_add( 
			GTK_CONTAINER(eventbox), get_picture_pixmap( YT_PIC_LOGO)); 

		gtk_box_pack_start( 
			GTK_BOX(yt->vbox), 
			eventbox, 
			FALSE, FALSE, 0 ); 
		gtk_signal_connect( 
			GTK_OBJECT(eventbox), 
			"button-press-event", 
			(GtkSignalFunc) _yopytoday_logo_click_cb, 
			(gpointer)yt); 
	}

	/* destroy callback
	 */
	gtk_signal_connect( 
		GTK_OBJECT(yt->window), 
		"delete_event", 
		(GtkSignalFunc) _yopytoday_destroy_cb, 
		(gpointer)yt); 

	return 1; 
}

int yopytoday_ReadConfiguration(YOPYTODAY yt, const char *configfile)
{
	FILE *fp=NULL; 
	char buf[1024]={0,}; 

	if (yt==NULL) return -1; 
	if (configfile==NULL) return -1; 

	printf("Loading configuration [%s]\n", configfile); 

	if ( (fp = fopen(configfile, "r"))==NULL)
		return -1; 

	while ( fgets( buf, 1024, fp)!=NULL)
	{
		/* skip invalid lines
		 */
		if (isspace(buf[0]) ) continue; 
		if (buf[0]=='#') continue; 

		/* delete CR/LF in the buffer
		 */
		if ( buf[ strlen(buf)-1 ] =='\n' ) 
			 buf[ strlen(buf)-1 ] = '\0'; 

		/* register given plugin
		 */
		yopytoday_RegisterPlugin( yt, buf ); 
	}


	fclose(fp); 

	return 1; 
}

int yopytoday_ScanPlugin(YOPYTODAY yt, const char *dir)
{
	DIR *dp; 
	struct dirent *dirp; 

	if (yt==NULL) return -1; 
	if (dir==NULL) return -1; 

	if ( (dp=opendir(dir))==NULL)
	{
		return -1; 
	}

	while ( (dirp=readdir(dp))!=NULL) 
	{
		char filename[1024]={0,}; 
		if ( strcmp( dirp->d_name, ".") == 0 )
			continue; 
		if ( strcmp( dirp->d_name, "..") == 0 )
			continue; 

		sprintf(filename, "%s/%s", dir, dirp->d_name); 
		if ( yopytoday_RegisterPlugin(yt, filename) > 0 )
			printf("registered [%s]\n", filename ); 
	}



	return 1; 
}

static gint _yopytoday_update_plugin( gpointer data)
{
	YT_PLUGIN p=(YT_PLUGIN)(data); 

	if (p==NULL) return 0; 

	if ( p->yt_plugin_update!=NULL)
		(*p->yt_plugin_update)(); 

	while ( gtk_events_pending() )
		gtk_main_iteration(); 

	return 1; 
}

int yopytoday_RegisterPlugin(YOPYTODAY yt, const char *plugin_path)
{
	void *libhandle=NULL; 
	YT_PLUGIN plugin=NULL; 
	YT_PLUGIN (*infofunc)(void) =NULL; 

	if (yt==NULL) return -1; 

	printf("Registering [%s]\n", plugin_path); 

	/* load given plungin 
	 */
	if ( (libhandle = dlopen(plugin_path, RTLD_NOW))==NULL)
		return -1; 

	/* get plugin info func
	 */
	if ( (infofunc = dlsym( libhandle, "yt_plugin_get_info") ) == NULL)
		goto return_error; 

	/* get plugin object from the info func
	 */	
	if ( (plugin = (*infofunc)())==NULL)
		goto return_error; 

	/* initialize the plugin 
	 */
	(*plugin->yt_plugin_initialize)(); 

	/* append the plugin window to the main widget, need a scrolled window
	 */
	{
		GtkWidget *plugin_hbox=NULL; 
		//GtkWidget *scrolledwin=NULL; 

		/* use horizontal box for the plugin
		 */
		plugin_hbox = gtk_hbox_new(FALSE, 0); 

		/* add plugin icon 
		 */
		if ( plugin->iconpath !=NULL )
		{
			char iconpath[512] = {0,}; 
			GtkWidget *eventbox; 

			eventbox = gtk_event_box_new(); 

			sprintf(iconpath, "%s/%s", YT_RESOURCE_DIR, plugin->iconpath); 
			gtk_container_add( 
				GTK_CONTAINER(eventbox), 
				get_picture_pixmap( iconpath)); 

			gtk_signal_connect( 
				GTK_OBJECT(eventbox), 
				"button-press-event", 
				(GtkSignalFunc) _yopytoday_plugin_icon_click_cb, 
				(gpointer)plugin); 

			gtk_box_pack_start( 
				GTK_BOX(plugin_hbox), 
				eventbox, 
				FALSE, FALSE, 2 ); 
		}

		/* add update timer 
		 */
		if ( plugin->update_delay > 0 )
			gtk_timeout_add( 
				plugin->update_delay, 
				_yopytoday_update_plugin, 
				plugin); 

		if ( (*plugin->yt_plugin_get_window)() !=NULL )
		{
			gtk_box_pack_start( 
				GTK_BOX(plugin_hbox), 
				(*plugin->yt_plugin_get_window)(), 
				FALSE, FALSE, 2 ); 
		}

		/* finally, append the plugin hbox to the main vbox 
		 */
		gtk_box_pack_start( 
			GTK_BOX(yt->vbox), 
			plugin_hbox, 
			FALSE, FALSE, 2 ); 
	}

	/* register the plugin itself
	 */
	yt->plugin_list = g_list_append(yt->plugin_list, plugin ); 

	return 1; 

return_error:
	if (libhandle!=NULL) dlclose(libhandle); 
	return -1; 
}

int yopytoday_UnregisterPluginAll(YOPYTODAY yt)
{
	GList *l=NULL; 

	if ( yt==NULL) return -1; 

	/* for each plugin in the list, finalize it
	 */
	for (l=yt->plugin_list; l!=NULL; l=l->next)
	{
		YT_PLUGIN plugin = (YT_PLUGIN)(l->data); 
		(*plugin->yt_plugin_finalize)(); 
		printf("Unregistered plugin [%s]\n", plugin->name); 
	}

	return 1; 	
}

int yopytoday_Resize(YOPYTODAY yt)
{
	GList *l=NULL; 
	int yres_sum=0; 

	if ( yt==NULL) return -1; 

	/* for each plugin in the list, get the size request
	 */
	for (l=yt->plugin_list; l!=NULL; l=l->next)
	{
		int xreq=0; 
		int yreq=0; 
		YT_PLUGIN plugin = (YT_PLUGIN)(l->data); 

		xreq = plugin->res_x_request; 
		yreq = plugin->res_y_request; 

		yres_sum += yreq; 

		printf("[%s] x=%d, y=%d\n", plugin->name, xreq, yreq); 
	}

	if ( SCREEN_HEIGHT >= yres_sum ) 
	{
		/* It's OK, set the requested widget sizes
		 */
		for (l=yt->plugin_list; l!=NULL; l=l->next)
		{
			int xreq=0; 
			int yreq=0; 
			YT_PLUGIN plugin = (YT_PLUGIN)(l->data); 
	
			xreq = plugin->res_x_request; 
			yreq = plugin->res_y_request; 

			gtk_widget_set_usize( (*plugin->yt_plugin_get_window)(), xreq, yreq); 
	
		}

	} 
	else 
	{
		/* FIXME: resize all the widgets to fit to the screen. 
		 * how can it be optimally scheduled ?
		 */


		/* It's OK, set the requested widget sizes
		 */
		for (l=yt->plugin_list; l!=NULL; l=l->next)
		{
			int xreq=0; 
			int yreq=0; 
			YT_PLUGIN plugin = (YT_PLUGIN)(l->data); 
	
			xreq = plugin->res_x_request; 
			yreq = plugin->res_y_request; 

			gtk_widget_set_usize( (*plugin->yt_plugin_get_window)(), xreq, yreq); 
	
		}


	}

	return 1; 	

}

int yopytoday_SetBackground(YOPYTODAY yt, const char *bgfile)
{
	if (yt==NULL) return -1; 
	if (bgfile==NULL) return -1; 

	/* FIXME:
	 * every plugin has its own widgets, 
	 * is it possible to have background?
	 *
	 * implement transparent widgets?
	 */
	return 1; 
}

int yopytoday_Show(YOPYTODAY yt)
{
	if (yt==NULL) return -1; 

	gtk_widget_show_all(yt->window); 

	return 1; 
}
