/*
 * sample plugin for yopytoday
 *
 * Choi Jonghwan <saxboy@freechal.com>
 * 2003/04/11
 */

#include <stdio.h>
#include "ytplugin.h"

static void yt_plugin_sample_initialize(void); 
static void yt_plugin_sample_finalize(void); 
static void yt_plugin_sample_update(void); 
static GtkWidget *yt_plugin_sample_get_window(void); 
static GtkWidget *yt_plugin_sample_get_config_window(void); 


_YT_PLUGIN g_yt_plugin_sample = 
{
	"yopytoday_sample_plugin",  	/* name*/
	"0.01",							/* version */ 
	"Choi Jonghwan",				/* author */ 
	"http://saxboy.wo.to",			/* url */ 
	"saxboy@freechal.com",			/* email */ 
	__DATE__,						/* build date */ 
	NULL,							/* icon path */ 
	5000,							/* update delay in milisec */ 
	240,							/* x size request */ 
	15,								/* y size request */ 
	yt_plugin_sample_initialize,	/* initializer */ 
	yt_plugin_sample_finalize,		/* finalizer */ 
	yt_plugin_sample_update,		/* update handler */ 
	yt_plugin_sample_get_window,	/* main window */ 
	yt_plugin_sample_get_config_window,	/* config window */ 

	/* internal */
	NULL							/* plugin path */
}; 


YT_PLUGIN yt_plugin_get_info(void)
{
	return &g_yt_plugin_sample; 
}


/* -------------------------------------------------------------
 * internal plugin routines. 
 */

static GtkWidget *ytpsample_window; 

static void yt_plugin_sample_initialize(void)
{
	ytpsample_window = gtk_label_new("hello, yopytoday"); 
	gtk_widget_show_all(ytpsample_window); 
}

static void yt_plugin_sample_finalize(void)
{
	gtk_widget_hide_all(ytpsample_window); 
}

static void yt_plugin_sample_update(void)
{
	static int update_count; 
	char cur_text[128]={0,}; 

	update_count++; 
	sprintf(cur_text, "hello, yopytoday update %d", update_count); 
	gtk_label_set_text( GTK_LABEL(ytpsample_window), cur_text); 
}
static GtkWidget *yt_plugin_sample_get_window(void)
{
	return ytpsample_window; 
}

static GtkWidget *yt_plugin_sample_get_config_window(void)
{
	return gtk_label_new("üâԴϴ"); 

}
