/*
 * showmonth plugin for yopytoday
 *
 * Choi Jonghwan <saxboy@freechal.com>
 * 2003/04/11
 */

#include <stdio.h>
#include "ytplugin.h"

static void yt_plugin_showmonth_initialize(void); 
static void yt_plugin_showmonth_finalize(void); 
static GtkWidget *yt_plugin_showmonth_get_window(void); 


_YT_PLUGIN g_yt_plugin_showmonth = 
{
	"yopytoday_showmonth_plugin", 
	"0.01", 
	"Choi Jonghwan", 
	"http://saxboy.wo.to", 
	"saxboy@freechal.com", 
	__DATE__, 
	"yt_plugin_calendar.png", 
	0, 
	200, 
	130, 
	yt_plugin_showmonth_initialize, 
	yt_plugin_showmonth_finalize, 
	NULL, 
	yt_plugin_showmonth_get_window, 
	NULL, 

	/* internal */
	NULL
}; 


YT_PLUGIN yt_plugin_get_info(void)
{
	return &g_yt_plugin_showmonth; 
}


/* -------------------------------------------------------------
 * internal plugin routines. 
 */

static GtkWidget *ytpshowmonth_window; 

static void yt_plugin_showmonth_initialize(void)
{
	time_t curtime; 
	struct tm cur_local_time; 

	ytpshowmonth_window = gtk_calendar_new(); 

	time(&curtime); 
	localtime_r( &curtime, &cur_local_time); 

	gtk_calendar_select_month( 
			GTK_CALENDAR( ytpshowmonth_window), 
			cur_local_time.tm_mon, 1900+cur_local_time.tm_year); 
	gtk_calendar_select_day( 
			GTK_CALENDAR( ytpshowmonth_window), 
			cur_local_time.tm_mday ); 

	gtk_widget_show_all(ytpshowmonth_window); 
}

static void yt_plugin_showmonth_finalize(void)
{
	gtk_widget_hide_all(ytpshowmonth_window); 
}

static GtkWidget *yt_plugin_showmonth_get_window(void)
{
	return ytpshowmonth_window; 
}
